(function(webapi, $){
    function safeAjax(ajaxOptions) {
        var deferredAjax = $.Deferred();
        shell.getTokenDeferred().done(function (token) {
            // add headers for AJAX
            if (!ajaxOptions.headers) {
                $.extend(ajaxOptions, {
                    headers: {
                        "__RequestVerificationToken": token
                    }
                });
            } else {
                ajaxOptions.headers["__RequestVerificationToken"] = token;
            }
            $.ajax(ajaxOptions)
                .done(function(data, textStatus, jqXHR) {
                    validateLoginSession(data, textStatus, jqXHR, deferredAjax.resolve);
                }).fail(deferredAjax.reject); //AJAX
        }).fail(function () {
            deferredAjax.rejectWith(this, arguments); /*on token failure pass the token AJAX and args*/
        });
        return deferredAjax.promise();
    }
    webapi.safeAjax = safeAjax;
})(window.webapi = window.webapi || {}, jQuery)


function loadRecords(url) {
    return webapi.safeAjax({
    type: "GET",
    url: url,
    contentType:"application/json",
    headers: {
        "Prefer": "odata.include-annotations=*"
    },
    success: function(res) {
        console.log(res)
        result = res;
    }
    });
}

function addRelation(url, dataObject) {
    webapi.safeAjax({
        type: "POST",
        url: url,
        contentType:"application/json",
        data: JSON.stringify(dataObject),
        success: function(res, status, xhr) {
            //print id of newly created entity record
            console.log("entityID: " + xhr.getResponseHeader("entityid"));
        }
    });

}

function removeRelation(url) {
    webapi.safeAjax({
        type: "DELETE",
        url: url,
        contentType:"application/json",
        success: function(res, status, xhr) {
            //print id of newly created entity record
            console.log("Element deleted!");
        }
    });
}

function loadRecords(url) {
    return webapi.safeAjax({
    type: "GET",
    url: url,
    contentType:"application/json",
    headers: {
        "Prefer": "odata.include-annotations=*"
    },
    success: function(res) {
        console.log(res)
        result = res;
    }
    });
}

$(document).ready(function() {
    // Change the name of all delete button
    var currentDeleteHtml = $('.btn-for-delete').html();
    if(currentDeleteHtml) {
        $('.btn-for-delete').html(currentDeleteHtml.replace('Delete', 'Supprimer'));
    }
});